/*                  -----===== Source for Xtuner =====-----                  */
/*                                                                           */
/*          Copyright (c) Mike Tinnes (tinnes@kitten.ndscs.nodak.edu)        */
/*                                                                           */
/*                original source completed 4-24-96 (ver. 1.00)              */
/*                 current source completed 12-18-96 (ver. 2.1)               */
/*                                                                           */
/*        THIS SOURCE IS PROVIDED UNDER THE GNU GENERAL PUBLIC LICENSE       */
/*                                                                           */
/*  Thanks to Lars Koeller (Lars_Koeller@odie.physik2.uni-rostock.de) for    */
/*  the port to FreeBSD!                                                     */
#include "xtuner.h"

/* Global variables */
xtuner_data_t xtuner_data;
mixer_data_t  mixer_data;
flags_t       flags;
FD_xtuner     *mainui;
FD_misc       *miscui;
Display       *dpy;
Window        window;
GC            canvasGC; 
GC	      toneGC; 

/* ======================================================================= */
/*  main loop                                                              */
/* ======================================================================= */
int main (int argc, char *argv[])
{   
  /* Check for valid cmd line options */
  parse_options(argc,argv);
  
  /* Check permissions and init volume etc.. */
  init_radio();
  
  /* Initialize xforms */
  dpy = fl_initialize(&argc, argv, 0, 0, 0);
  
  /* Create forms */
  mainui = create_form_xtuner();
  miscui = create_form_misc();
  
  /* Initialize mixer */
  init_hw();  
  if (mixer_data.mixer_supp)
    query_status();
  
  init_canvasGC(mainui);
   
  /* We're ready to display the form */
  fl_show_form(mainui->xtuner, FL_PLACE_SIZE, FL_FULLBORDER, "Xtuner - OFF");
  
  /* Initialize the LED and display it */
  init_LED(mainui);
  
  /* Do the form */
  fl_do_forms();
  
  /* When done remove the form */
  fl_hide_form(mainui->xtuner);
  
  /* Save presets just in case */
  write_file();
  
  /* Cleanup */
  #if (defined(BSD) && (BSD >= 199306))
  close(fpiopl);
  #else
  ioperm(xtuner_data.rport, 2, 0);
  #endif
  
  return 0;
}
